<?php

/***************************************************************************

           TPLN  by HAYOUN Laurent

           website: http://tpln.sourceforge.net
           email: php_work@hotmail.com

***************************************************************************/



class TPLN_Error extends TPLN_Debug
{
 var $error_msg;
 var $error_signaled = array();


 // Gestiond des erreurs
 function _Error($err_no,$file="",$bloc="",$item="")
 {
   $file_color = "#FF0000";
   $item_color = "#0000FF";
   $bloc_color = "#008000";

  switch($err_no)
    {
         // 0 pas de fichier trouv
         case 0:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "File <font color=\"$file_color\"><b>$file</b></font> not found";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Fichier <font color=\"$file_color\"><b>$file</b></font> non trouv";}
         break;

         // 1 item non trouv
         case 1 :
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> not found in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> non trouv dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 1 item non trouv dans le bloc
         case 1.1 :
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> not found in bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> of file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Item <font color=\"$item_color\">\{$item}</font> non trouv dans le bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> du fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 2 bloc inexistant
         case 2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> not found in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> non trouv dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 2.1 bloc double
         case 2.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font>is in double in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font>est en double dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 3 bloc inexistant dans un bloc
         case 3:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> not found in Bloc <font color=\"$item_color\">\{$item}</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Bloc <font color=\"$bloc_color\">&lt;bloc::$bloc&gt;</font> non trouv dans le bloc <font color=\"$item_color\">\{$item}</font> du fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 4 chemin du bloc error
        case 4:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc path <font color=\"$item_color\">$bloc</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Chemin du bloc <font color=\"$item_color\">$bloc</font> dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 4.1 chemin du bloc error in a loop bloc
        case 4.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc path <font color=\"$item_color\">$bloc</font> in Loop function of file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Chemin du bloc <font color=\"$item_color\">$bloc</font> dans la fonction Loop du fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 4.2 chemin du bloc error in looped bloc
        case 4.2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Bloc path <font color=\"$item_color\">$bloc</font> is already looped in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Chemin du bloc <font color=\"$item_color\">$bloc</font> est dj dfini comme Loop dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

        // 5 define a bloc
        case 5:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't define an empty bloc";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux dfinir un bloc vide";}
         break;

        // 6 define an item
        case 6:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't define an empty item";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux dfinir un item vide";}
         break;

         // 7 impossible cache directory creation
         case 7:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't create cache dir ".TPLN_CACHE_DIR;}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux crer le rpertoire de cache ".TPLN_CACHE_DIR;}
         break;

         // 7.1 impossible cache directory creation
         case 7.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't create dir ".$file;}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux crer le rpertoire de cache ".$file;}
         break;

         // 7.2 impossible de trouver le repertoire par dfaut
         case 7.2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't create default templates directory ".TPLN_DEFAULT_PATH;}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux crer le rpertoire de templates par dfaut ".TPLN_DEFAULT_PATH;}
         break;




         // 8 impossible de trouver la fin du bloc
         case 8:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Can't find end bloc <font color=\"$bloc_color\">$bloc</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Ne peux trouver la fin du bloc  <font color=\"$bloc_color\">$bloc</font> dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;

         // 9 le template n'existe pas
         case 9:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template number $file is not an integer";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'est pas un intgral";}
         break;

         // 10 le template n'existe pas
         case 10:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template number $file doesn't exist";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'existe pas";}
         break;

         // 11 le nom du template n'existe pas
         case 11:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Template name $file doesn't defined";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Template $file n'est pas dfini";}
         break;


         // 12 DefineTemplate
         case 12:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "DefineTemplate() must have an array in parameter";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "La fonction DefineTemplate() doit avoir un array en parametre";}
         break;

         // 13 CreateFieldVars
         case 13:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Your bloc path must have a father <font color=\"$bloc_color\">$bloc</font> in file <font color=\"$file_color\"><b>$file</b></font>";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Votre chemin de bloc doit avoir un pere  <font color=\"$bloc_color\">$bloc</font> dans le fichier <font color=\"$file_color\"><b>$file</b></font>";}
         break;


    }

    $this->error_msg = "<B>TPLN Error $err_no:</B> $err_msg";
    $this->_OutPutMessage();
 }

 function _DBError($err_no,$msg="")
 {
   // 0 problem de connexion
   switch($err_no)
    {
        case 0:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Database connection problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Problme de connexion  la base ($msg)";}
         break;

        // object $db non existant
        case 0.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "No connection found";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Pas de connection trouv";}
         break;

        // 1 problem de connexion
        case 1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Database close problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Problme de fermeture  la base ($msg)";}
        break;

        // 2 problem MySQL !
        case 2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Query problem ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Probleme de requete ($msg)";}
        break;

        // 2.1 problem avec le changement de dommain
        case 2.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Change connection index ($msg)";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Index du changement de connection ($msg)";}
        break;

        // objet requte
        case 2.2:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "No query found";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Pas de requte trouve";}
        break;

        // field index number
        case 2.3:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Colonne number,not valide";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Colonne de rsultats non valide";}
        break;

        // ShowRecords
        // problem dans la construction de la requete
        case 3:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "SELECT not found in your query";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "SELECT non trouv dans votre requte";}
        break;

        case 4:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "FROM not found in your query";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "FROM non trouv dans votre requte";}
        break;

        // problem avec le nombre de resultats voulus
        // pas un entier
         case 5:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Showrecords() must have an integer in second parameter";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Showrecords() doit avoir un entier en second paramtre";}
        break;
        case 5.1:
             if(TPLN_ERROR_LANG == "en"){$err_msg = "Showrecords() must have integer greater than zero in second parameter";}
             if(TPLN_ERROR_LANG == "fr"){$err_msg = "Showrecords() doit avoir un entier suprieur  zero en second paramtre";}
        break;

    }

    $this->error_msg = "<B>TPLN DB Error $err_no:</B> $err_msg";
    $this->_OutPutMessage();
 }

// ben alert par email de l'admin
 function _MailAlert()
 {

  $err_alert = TPLN_ERROR_ALERT;
  $mail_admin = TPLN_MAIL_ADMIN;

   if(($err_alert == 1) && (!empty($mail_admin)) && $_GET["tpln_w"] != "adm")
   {
    $request_url_simple = str_replace("?".$_SERVER["QUERY_STRING"],"",$_SERVER["REQUEST_URI"]);
    $url = "http://".$_SERVER["HTTP_HOST"].$request_url_simple."?tpln_w=adm";

    $subject = "[TPLN] Alert Error";

    $body = date("[Y-m-d H:i] ")." TPLN has detected an error\n\n";
    $body .= strip_tags($this->error_msg)." in ".$_SERVER["SCRIPT_FILENAME"]."\n\n\n";
    $body .= "Url $url\n";
    $body .= "===========================================\n";
    $body .= "TPLN version 1.2\n";
    $body .= "http://tpln.sourceforge.net";

    $from = "From: TPLN<".TPLN_MAIL_EXPEDITOR.">\n";
    $from .= "X-Mailer: PHP/". phpversion();


        if(@mail(TPLN_MAIL_ADMIN,$subject,$body,$from))
         {
           if(TPLN_ERROR_LANG == "en"){$msg = "<br><br><hr>An email has been sent to the webmaster <a href=\"mailto:$mail_admin\">$mail_admin</a>";}
           if(TPLN_ERROR_LANG == "fr"){$msg = "<br><br><hr>Un Email a t envoy au webmaster <a href=\"mailto:$mail_admin\">$mail_admin</a>";}

           $this->error_msg .= $msg;
         }

   }

 }

// pour la sortie du message
function _OutPutMessage()
 {
   $this->_MailAlert();

   if(!@in_array($this->error_msg,$this->error_signaled))
    {
     echo $this->error_msg;
     echo "<br/>\n";
     $this->error_signaled[] = $this->error_msg;
    }
    
   // logs des erreurs
   if(TPLN_ERROR_LOGS == 1)
   {
      // on regarde si le fichier existe sinon on le cre
      if($fp = fopen(TPLN_ERROR_LOGS_FILE ,"a"))
      {
         // jour heure,msg
         $txt = date("d-m-j H:i,").$this->error_msg."\n"; 
         fwrite($fp, $txt);
         fclose($fp);
      }
      
      
     
   }

   if($this->struct_mode == 0)
    {
      exit();
    }
 }

}

?>